fs=10;
scrsz = get(0,'ScreenSize');
figure('Units','centimeters','Position',[8 2 27 27])
set(gcf,'papersize',[27,25])
fig = gcf;
style = hgexport('factorystyle');
style.Bounds = 'tight';
hgexport(fig,'-clipboard',style,'applystyle', true);
drawnow;
t_tot=90;
%% Figure 5: Monitoring module decisions and sensor switching 
%figure
subplot(2,3,1);
set(gca,"FontSize",20)
%dec_2_1=squeeze(results.dec_logic2{1}.Values.Data(1,1,:))';
yyaxis left
plot(results.Power_profile_performance{1}.Values.Time,results.k_fuel_engine{1}.Values.Data,'LineWidth',2,'color','b')
ylim([0 4])
ylabel("$\sigma^{(2)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
yticks([0:1:4])
yyaxis right
plot(results.Power_profile_performance{1}.Values.Time,results.dec_logic2{1}.Values.Data(:,1),'LineWidth',1,'color','r','LineStyle','-.');
ylim([0 1.05])
ylabel("$D^{(2,1)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
yticks([0:.5:1.05])
xticks([0:10:90])
grid minor;
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman')
title('(a)','interpreter','latex','FontSize',25,'FontName','Times New Roman','color','k')
xlim([0,90])
subplot(2,3,4);
set(gca,"FontSize",20)
yyaxis left
plot(results.Power_profile_performance{1}.Values.Time,results.k_motor{1}.Values.Data,'LineWidth',2,'color','b')
ylabel("$\sigma^{(5)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
ylim([0 4])
yticks([0:1:3])
yyaxis right
plot(results.Power_profile_performance{1}.Values.Time,results.dec_logic5{2}.Values.Data,'LineWidth',1,'color','r','LineStyle','-.');
ylim([0 1.05])
yticks([0:.5:1.05])
xticks([0:10:90])
grid minor;
ylabel("$D^{(5)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman')
title('(d)','interpreter','latex','FontSize',25,'FontName','Times New Roman','color','k')
xlim([0,90])
subplot(2,3,2)
set(gca,"FontSize",20)
%plot(results.Power_profile_performance{1}.Values.Time,results.analythical_conditions{2}.Values.Data,'b');
plot(results.Power_profile_performance{1}.Values.Time,results.analythical_conditions{2}.Values.Data>0,'r--');
%hold on
%plot(results.Power_profile_performance{1}.Values.Time,0*results.analythical_conditions{2}.Values.Data,'r--');
%ylim([-4,16])
ylim([0,1.2])
yticks([0,1])
xticks([0:10:90])
ylabel('Condition 1','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
grid minor;
xlim([0,90])
title('(b)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
subplot(2,3,3)
set(gca,"FontSize",20)
plot(results.Power_profile_performance{1}.Values.Time,results.analythical_conditions{3}.Values.Data(:,2)<0,'r--');
%hold on 
%plot(results.Power_profile_performance{1}.Values.Time,0*results.analythical_conditions{3}.Values.Data,'r--');
ylabel('Condition 2','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
%ylim([-12,2])
ylim([0,1.2])
yticks([0,1])
grid minor;
xticks([0:10:90])
xlim([0,90])
title('(c)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
%% Figure 6: Monitoring module fault estimation accurracy
yyaxis left
plot(results.Power_profile_performance{1}.Values.Time,abs(results.speed_vs_performance{1}.Values.Data),'m');
hold on 
plot(results.Power_profile_performance{1}.Values.Time,abs(results.f2_f2_hat{1}.Values.Data(:,1)-results.speed_vs_performance{3}.Values.Data),'b--');
%plot(results.Power_profile_performance{1}.Values.Time,0*results.analythical_conditions{3}.Values.Data,'r--');
ylabel('$$\left|y^{(2)}_1-\hat{x}_1^{(2)}-\hat{f}_1^{(2)}\right|\;(rps)$$','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
%ylim([-12,2])
ylim([0,2.1])
yticks([0,1,2])
yyaxis right
plot(results.Power_profile_performance{1}.Values.Time,results.dec_logic2{1}.Values.Data(:,1),'LineWidth',1,'color','r','LineStyle','-.');
ylim([0 1.05])
ylabel("$D^{(2,1)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
yticks([0:.5:1.05])
grid minor;
legend('Differential VS','Algebraic VS','SFDI decision')
xticks([0:10:90])
xlim([0,90])
set(gca,"FontSize",20)
%% Figure 7: Monitoring module fault estimation accurracy
yyaxis left
plot(results.e_fmotor.Time,abs(results.e_fmotor.Data)/10^4,'m');
%hold on 
%plot(results.Power_profile_performance{1}.Values.Time,abs(results.f2_f2_hat{1}.Values.Data(:,1)-results.speed_vs_performance{3}.Values.Data),'b--');
%plot(results.Power_profile_performance{1}.Values.Time,0*results.analythical_conditions{3}.Values.Data,'r--');
ylabel('$$\left|y^{(5)}_1-\hat{x}_1^{(5)}-\hat{f}_1^{(5)}\right|\;(N\cdot m)$$ ','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
%legend('Dynamic VS','Static VS')
%ylim([-12,2])
ylim([0,5.2])
yticks([0:1:5])
yyaxis right
plot(results.Power_profile_performance{1}.Values.Time,results.dec_logic5{2}.Values.Data,'LineWidth',1,'color','r','LineStyle','-.');
ylim([0 1.05])
yticks([0:.5:1.05])
xticks([0:10:90])
grid minor;
ylabel("$D^{(5)}$",'interpreter','latex','FontSize',24,'FontName','Times New Roman')
%grid minor;
xticks([0:10:90])
xlim([0,90])
legend("Algebraic VS","SFDI decision")
set(gca,"FontSize",20)
%% Figure 8: Control agents and reference tracking errors
subplot(2,2,1)
plot(results.Power_profile_performance{1}.Values.Time,results.controller_speed{1}.Values.Data,'b');
ylabel('$u^{(2)}$','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
ylim([0.7,1.1])
grid minor;
xticks([0:10:90])
xlim([0,90])
yticks([0.7:0.1:1.1])
title('(a)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
set(gca,"FontSize",20)
subplot(2,2,2)
plot(results.Power_profile_performance{1}.Values.Time,results.controller_torque{1}.Values.Data,'b');
ylabel('$u^{(5)}$','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
ylim([15,35])
grid minor;
xticks([0:10:90])
xlim([0,90])
title('(b)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
set(gca,"FontSize",20)
subplot(2,2,3)
plot(results.Power_profile_performance{1}.Values.Time,abs(results.controller_speed{2}.Values.Data)./results.shaft_speed_performance{1}.Values.Data(:,2)*100,'m');
ylabel('$APE^{(2)}=\frac{100\cdot\left(\hat{x}^{(2)}-n_D\right)}{n_D}\;[\%]$','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
ylim([-1,10])
grid minor;
xticks([0:10:90])
xlim([0,90])
yticks([0:2:10])
title('(c)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
set(gca,"FontSize",20)
subplot(2,2,4)
plot(results.Power_profile_performance{1}.Values.Time,abs(results.controller_torque{2}.Values.Data)./results.motor_torque_performance{1}.Values.Data(:,1)*100,'m');
ylabel('$APE^{(5)}=\frac{100\cdot\left(\hat{z}^{(5)}-Q_D\right)}{Q_D}\;[\%]$','interpreter','latex','FontSize',24,'FontName','Times New Roman')
xlabel('Time (sec)' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman');
ylim([-1,12])
grid minor;
xticks([0:10:90])
yticks([0:2:10])
xlim([0,90])
title('(d)','interpreter','latex','FontSize',24,'FontName','Times New Roman');
set(gca,"FontSize",20)
%%
esp=(results.shaft_speed_performance{1}.Values.Data(:,1)-results.shaft_speed_performance{1}.Values.Data(:,2))./(results.shaft_speed_performance{1}.Values.Data(:,2));
Qsp=(results.motor_torque_performance{1}.Values.Data(:,1)-results.motor_torque_performance{1}.Values.Data(:,2))./(results.motor_torque_performance{1}.Values.Data(:,1));
Psp=(results.Power_profile_performance{1}.Values.Data(:,1)/1000-results.Power_profile_performance{1}.Values.Data(:,2)/1000)./(results.Power_profile_performance{1}.Values.Data(:,2)/1000);
mean_error_values=100*[mean(abs(esp(results.Power_profile_performance{1}.Values.Time>=20)));mean(abs(Qsp(results.Power_profile_performance{1}.Values.Time>=70)));mean(abs(Psp(results.Power_profile_performance{1}.Values.Time>=70)))]

%%
% figure
plot(results.Power_profile_performance{1}.Values.Time,results.Power_profile_performance{1}.Values.Data(:,1)/10^6,'g','LineWidth',1.5)
hold on
plot(results.Power_profile_performance{1}.Values.Time,results.Power_profile_performance{1}.Values.Data(:,2)/10^6,'r--','LineWidth',1.5)
ylabel('$$P_D$$ [MW]','FontSize',24,'FontName','Times New Roman','interpreter','latex')
xlabel('Time [sec]' ,'interpreter','latex','FontSize',24,'FontName','Times New Roman')
grid minor;
xlim([0,90])
%title('Power profile tracking performance','FontSize',24,'FontName','Times New Roman')
set(gca,"FontSize",20)